package jmel.script;

public class AddUtils 
{
	public static int add(boolean b1, boolean b2) { return (b1?1:0)+(b2?1:0); }
	public static int add(boolean b, int i2) { return (b?1:0)+i2; }
	public static float add(boolean b, float f) { return (b?1:0)+f; }
	public static double add(boolean b, double d) { return (b?1:0)+d; }
	public static String add(boolean b, String s) { return (b?"true":"false")+s; }
	public static MelVector add(boolean b, MelVector v) { return v.add(b?1:0); }
	public static MelMatrix add(boolean b, MelMatrix m) { return ConvUtils.toMatrix(b).add(m); }
	public static Object add(boolean b, Object o) { 
		int value = b ? 1 : 0;
		if (o instanceof Boolean) return new Integer(value+(((Boolean)o).booleanValue()?1:0)); 
		if (o instanceof Integer) return new Integer(value+((Integer)o).intValue()); 
		if (o instanceof Float) return new Float(value+((Float)o).floatValue()); 
		if (o instanceof Double) return new Double(value+((Double)o).doubleValue()); 
		if (o instanceof String) return value+(String)o; 
		if (o instanceof MelVector) return ((MelVector)o).add(value); 
		if (o instanceof MelMatrix) return ConvUtils.toMatrix(value).add((MelMatrix)o); 
		return new Integer(0);
	}


	public static int add(int i, boolean b) { return i+(b?1:0); }
	public static int add(int i1, int i2) { return i1+i2; }
	public static float add(int i, float f) { return i+f; }
	public static double add(int i, double d) { return i+d; }
	public static String add(int i, String s) { return i+s; }
	public static MelVector add(int i, MelVector v) { return v.add(i); }
	public static MelMatrix add(int i, MelMatrix m) { return ConvUtils.toMatrix(i).add(m); }
	public static Object add(int i, Object o) { 
		if (o instanceof Boolean) return new Integer(i+(((Boolean)o).booleanValue()?1:0)); 
		if (o instanceof Integer) return new Integer(i+((Integer)o).intValue()); 
		if (o instanceof Float) return new Float(i+((Float)o).floatValue()); 
		if (o instanceof Double) return new Double(i+((Double)o).doubleValue()); 
		if (o instanceof String) return i+(String)o; 
		if (o instanceof MelVector) return ((MelVector)o).add(i); 
		if (o instanceof MelMatrix) return ConvUtils.toMatrix(i).add((MelMatrix)o); 
		return new Integer(0);
	}
	
	
	public static float add(float f, boolean b) { return f+(b?1.0F:0.0F); }
	public static float add(float f, int i) { return f+i; }
	public static float add(float f1, float f2) { return f1+f2; }
	public static double add(float f, double d) { return f+d; }
	public static String add(float f, String s) { return f+s; }
	public static MelVector add(float f, MelVector v) { return v.add(f); }
	public static MelMatrix add(float f, MelMatrix m) { return ConvUtils.toMatrix(f).add(m); }
	public static Object add(float f, Object o) {
		if (o instanceof Boolean) return new Float(f+(((Boolean)o).booleanValue()?1:0)); 
		if (o instanceof Integer) return new Float(f+((Integer)o).intValue()); 
		if (o instanceof Float) return new Float(f+((Float)o).floatValue()); 
		if (o instanceof Double) return new Double(f+((Double)o).doubleValue()); 
		if (o instanceof String) return f+(String)o; 
		if (o instanceof MelVector) return ((MelVector)o).add(f); 
		if (o instanceof MelMatrix) return ConvUtils.toMatrix(f).add((MelMatrix)o); 
		return new Integer(0);
	}
	
	
	public static double add(double d, boolean b) { return d+(b?1.0D:0.0D); }
	public static double add(double d, int i) { return d+i; }
	public static double add(double d, float f) { return d+f; }
	public static double add(double d1, double d2) { return d1+d2; }
	public static String add(double d, String s) { return d+s; }
	public static MelVector add(double d, MelVector v) { return v.add((float)d); }
	public static MelMatrix add(double d, MelMatrix m) { return ConvUtils.toMatrix(d).add(m); }
	public static Object add(double d, Object o) { 
		if (o instanceof Boolean) return new Double(d+(((Boolean)o).booleanValue()?1:0)); 
		if (o instanceof Integer) return new Double(d+((Integer)o).intValue()); 
		if (o instanceof Float) return new Double(d+((Float)o).floatValue()); 
		if (o instanceof Double) return new Double(d+((Double)o).doubleValue()); 
		if (o instanceof String) return d+(String)o; 
		if (o instanceof MelVector) return ((MelVector)o).add((float)d); 
		if (o instanceof MelMatrix) return ConvUtils.toMatrix(d).add((MelMatrix)o); 
		return new Integer(0);
	}
	
	
	public static String add(String s, boolean b) { return s+(b?"true":"false"); }
	public static String add(String s, int i) { return s+i; }
	public static String add(String s, float f) { return s+f; }
	public static String add(String s, double d) { return s+d; }
	public static String add(String s1, String s2) { return s1+s2; }
	public static String add(String s, MelVector v) { return s+v.toString(); }
	public static String add(String s, MelMatrix m) { return s+m.toString(); }
	public static String add(String s, Object o) { return s+o.toString(); }
	
	
	public static MelVector add(MelVector v, boolean b) { return v.add(b?1:0); }
	public static MelVector add(MelVector v, int i) { return v.add(i); }
	public static MelVector add(MelVector v, float f) { return v.add(f); }
	public static MelVector add(MelVector v, double d) { return v.add((float)d); }
	public static String add(MelVector v, String s) { return v.toString()+s; }
	public static MelVector add(MelVector v1, MelVector v2) { return v1.add(v2); }
	public static MelVector add(MelVector v, MelMatrix m) { return v.add(ConvUtils.toVector(m)); }
	public static Object add(MelVector v, Object o) { 
		if (o instanceof Boolean) return v.add(((Boolean)o).booleanValue()?1:0); 
		if (o instanceof Integer) return v.add(((Integer)o).intValue()); 
		if (o instanceof Float) return v.add(((Float)o).floatValue()); 
		if (o instanceof Double) return v.add((float)((Double)o).doubleValue()); 
		if (o instanceof String) return v+(String)o; 
		if (o instanceof MelVector) return ((MelVector)o).add(v); 
		if (o instanceof MelMatrix) return v.add(ConvUtils.toVector((MelMatrix)o)); 
		return new Integer(0);
	}
	

	public static MelMatrix add(MelMatrix m, boolean b) { return m.add(ConvUtils.toMatrix(b?1:0)); }
	public static MelMatrix add(MelMatrix m, int i) { return m.add(ConvUtils.toMatrix(i)); }
	public static MelMatrix add(MelMatrix m, float f) { return m.add(ConvUtils.toMatrix(f)); }
	public static MelMatrix add(MelMatrix m, double d) { return m.add(ConvUtils.toMatrix((float)d)); }
	public static String add(MelMatrix m, String s) { return m.toString()+s; }
	public static MelMatrix add(MelMatrix m, MelVector v) { return m.add(ConvUtils.toMatrix(v)); }
	public static MelMatrix add(MelMatrix m1, MelMatrix m2) { return m1.add(m2); }
	public static Object add(MelMatrix m, Object o) { 
		if (o instanceof Boolean) return m.add(ConvUtils.toMatrix(((Boolean)o).booleanValue()?1:0)); 
		if (o instanceof Integer) return m.add(ConvUtils.toMatrix(((Integer)o).intValue())); 
		if (o instanceof Float) return m.add(ConvUtils.toMatrix(((Float)o).floatValue())); 
		if (o instanceof Double) return m.add(ConvUtils.toMatrix((float)((Double)o).doubleValue())); 
		if (o instanceof String) return m+(String)o; 
		if (o instanceof MelVector) return m.add(ConvUtils.toMatrix((MelVector)o)); 
		if (o instanceof MelMatrix) return m.add((MelMatrix)o); 
		return new Integer(0);
	}
	

	public static Object add(Object o, boolean b) { return add(o, new Boolean(b)); }
	public static Object add(Object o, int i) { return add(o, new Integer(i)); }
	public static Object add(Object o, float f) { return add(o, new Float(f)); }
	public static Object add(Object o, double d) { return add(o, new Double(d)); }
	public static String add(Object o, String s) { return o.toString()+s; }
	public static Object add(Object o, MelVector v) { 
		if (o instanceof Integer) return add(((Integer)o).intValue(), v); 
		if (o instanceof Boolean) return add(((Boolean)o).booleanValue(), v); 
		if (o instanceof Float) return add(((Float)o).floatValue(), v); 
		if (o instanceof Double) return add(((Double)o).doubleValue(), v); 
		if (o instanceof String) return o+v.toString(); 
		if (o instanceof MelVector) return add((MelVector)o, v); 
		if (o instanceof MelMatrix) return add((MelMatrix)o, v); 
		return new Integer(0);
	}
	public static Object add(Object o, MelMatrix m) { 
		if (o instanceof Integer) return add(((Integer)o).intValue(), m); 
		if (o instanceof Boolean) return add(((Boolean)o).booleanValue(), m); 
		if (o instanceof Float) return add(((Float)o).floatValue(), m); 
		if (o instanceof Double) return add(((Double)o).doubleValue(), m); 
		if (o instanceof String) return o+m.toString(); 
		if (o instanceof MelVector) return add((MelVector)o, m); 
		if (o instanceof MelMatrix) return add((MelMatrix)o, m); 
		return new Integer(0);
	}
	public static Object add(Object o1, Object o2) { 
		if (o2 instanceof Integer) return add(o1, ((Integer)o2).intValue()); 
		if (o2 instanceof Boolean) return add(o1, ((Boolean)o2).booleanValue()); 
		if (o2 instanceof Float) return add(o1, ((Float)o2).floatValue()); 
		if (o2 instanceof Double) return add(o1, ((Double)o2).doubleValue()); 
		if (o2 instanceof String) return add(o1, (String)o2); 
		if (o2 instanceof MelVector) return add(o1, (MelVector)o2); 
		if (o2 instanceof MelMatrix) return add(o1, (MelMatrix)o2); 
		return new Integer(0);
	}
}