package jmel.script;

public class MelArrayFloat extends MelArray
{
	public MelArrayFloat(Object value) {
		super(float.class, value);
	}
	
	public float 	getElement(int i) { return ((Float)readElement(i)).floatValue(); }
	public float 	getElement(int i, int j) { return ((Float)readElement(i,j)).floatValue(); }

	public void setElement(int i, float o) { writeElement(i, new Float(o)); }
	public void setElement(int i, int j, float o) { writeElement(i, j, new Float(o)); }
	
	public float[] get() { return (float[])getValue(); }
	
	public void setValue(int i, Object val) {
		if (val instanceof Number) val = new Float(((Number)val).floatValue());
		writeElement(i,val);
	}
	
	public void setValue(int i, int j, Object val) {
		if (val instanceof Number) val = new Float(((Number)val).floatValue());
		writeElement(i,j,val);
	}
}