package jmel.script;

public class ModUtils 
{
	public static int mod(boolean b1, boolean b2) { return (b1?1:0)%(b2?1:0); }
	public static int mod(boolean b, int i2) { return (b?1:0)%i2; }
	public static float mod(boolean b, float f) { return (b?1:0)%f; }
	public static double mod(boolean b, double d) { return (b?1:0)%d; }
	public static String mod(boolean b, String s) { return b+"%"+s; }
	public static float mod(boolean b, MelVector v) { return (b?1:0)%v.length(); }
	public static float mod(boolean b, MelMatrix m) { return (b?1:0)%m.length(); }
	public static Object mod(boolean b, Object o) { 
		int value = b ? 1 : 0;
		if (o instanceof Boolean) return new Integer(value%(((Boolean)o).booleanValue()?1:0)); 
		if (o instanceof Integer) return new Integer(value%((Integer)o).intValue()); 
		if (o instanceof Float) return new Float(value%((Float)o).floatValue()); 
		if (o instanceof Double) return new Double(value%((Double)o).doubleValue()); 
		if (o instanceof String) return b+"%"+(String)o; 
		if (o instanceof MelVector) return new Float(value%((MelVector)o).length());
		if (o instanceof MelMatrix) return new Float(value%((MelMatrix)o).length());
		return new Integer(0);
	}


	public static int mod(int i, boolean b) { return i%(b?1:0); }
	public static int mod(int i1, int i2) { return i1%i2; }
	public static float mod(int i, float f) { return i%f; }
	public static double mod(int i, double d) { return i%d; }
	public static String mod(int i, String s) { return i+"%"+s; }
	public static float mod(int i, MelVector v) { return i%v.length(); }
	public static float mod(int i, MelMatrix m) { return i%m.length(); }
	public static Object mod(int i, Object o) { 
		if (o instanceof Boolean) return new Integer(i%(((Boolean)o).booleanValue()?1:0)); 
		if (o instanceof Integer) return new Integer(i%((Integer)o).intValue()); 
		if (o instanceof Float) return new Float(i%((Float)o).floatValue()); 
		if (o instanceof Double) return new Double(i%((Double)o).doubleValue()); 
		if (o instanceof String) return i+"%"+(String)o; 
		if (o instanceof MelVector) return new Float(i%((MelVector)o).length());
		if (o instanceof MelMatrix) return new Float(i%((MelMatrix)o).length());
		return new Integer(0);
	}
	
	
	public static float mod(float f, boolean b) { return f%(b?1.0F:0.0F); }
	public static float mod(float f, int i) { return f%i; }
	public static float mod(float f1, float f2) { return f1%f2; }
	public static double mod(float f, double d) { return f%d; }
	public static String mod(float f, String s) { return f+"%"+s; }
	public static float mod(float f, MelVector v) { return f%v.length(); }
	public static float mod(float f, MelMatrix m) { return f%m.length(); }
	public static Object mod(float f, Object o) {
		if (o instanceof Boolean) return new Float(f%(((Boolean)o).booleanValue()?1:0)); 
		if (o instanceof Integer) return new Float(f%((Integer)o).intValue()); 
		if (o instanceof Float) return new Float(f%((Float)o).floatValue()); 
		if (o instanceof Double) return new Double(f%((Double)o).doubleValue()); 
		if (o instanceof String) return f+"%"+(String)o; 
		if (o instanceof MelVector) return new Float(f%((MelVector)o).length());
		if (o instanceof MelMatrix) return new Float(f%((MelMatrix)o).length());
		return new Integer(0);
	}
	
	
	public static double mod(double d, boolean b) { return d%(b?1.0D:0.0D); }
	public static double mod(double d, int i) { return d%i; }
	public static double mod(double d, float f) { return d%f; }
	public static double mod(double d1, double d2) { return d1%d2; }
	public static String mod(double d, String s) { return d+"%"+s; }
	public static float mod(double d, MelVector v) { return ((float)d)%v.length(); }
	public static float mod(double d, MelMatrix m) { return ((float)d)%m.length(); }
	public static Object mod(double d, Object o) { 
		if (o instanceof Boolean) return new Double(d%(((Boolean)o).booleanValue()?1:0)); 
		if (o instanceof Integer) return new Double(d%((Integer)o).intValue()); 
		if (o instanceof Float) return new Double(d%((Float)o).floatValue()); 
		if (o instanceof Double) return new Double(d%((Double)o).doubleValue()); 
		if (o instanceof String) return d+"%"+(String)o; 
		if (o instanceof MelVector) return new Float(((float)d)%((MelVector)o).length());
		if (o instanceof MelMatrix) return new Float(((float)d)%((MelMatrix)o).length());
		return new Integer(0);
	}
	
	
	public static String mod(String s, boolean b) { return s+"%"+(b?"1":"0"); }
	public static String mod(String s, int i) { return s+"%"+i; }
	public static String mod(String s, float f) { return s+"%"+f; }
	public static String mod(String s, double d) { return s+"%"+d; }
	public static String mod(String s1, String s2) { return s1+"%"+s2; }
	public static String mod(String s, MelVector v) { return s+"%"+v.toString(); }
	public static String mod(String s, MelMatrix m) { return s+"%"+m.toString(); }
	public static String mod(String s, Object o) { return s+"%"+o.toString(); }
	
	
	public static MelVector mod(MelVector v, boolean b) { return v.mod(b?1:0); }
	public static MelVector mod(MelVector v, int i) { return v.mod(i); }
	public static MelVector mod(MelVector v, float f) { return v.mod(f); }
	public static MelVector mod(MelVector v, double d) { return v.mod((float)d); }
	public static String mod(MelVector v, String s) { return v.toString()+"%"+s; }
	public static MelVector mod(MelVector v1, MelVector v2) { return v1.mod(v2); }
	public static MelVector mod(MelVector v, MelMatrix m) { return v.mod(ConvUtils.toVector(m)); }
	public static Object mod(MelVector v, Object o) { 
		if (o instanceof Boolean) return v.mod(((Boolean)o).booleanValue()?1:0); 
		if (o instanceof Integer) return v.mod(((Integer)o).intValue()); 
		if (o instanceof Float) return v.mod(((Float)o).floatValue()); 
		if (o instanceof Double) return v.mod((float)((Double)o).doubleValue()); 
		if (o instanceof String) return v+"%"+(String)o; 
		if (o instanceof MelVector) return v.mod((MelVector)o); 
		if (o instanceof MelMatrix) return v.mod(ConvUtils.toVector((MelMatrix)o)); 
		return new Integer(0);
	}
	

	public static MelMatrix mod(MelMatrix m, boolean b) { return m.mod(b?1:0); }
	public static MelMatrix mod(MelMatrix m, int i) { return m.mod(i); }
	public static MelMatrix mod(MelMatrix m, float f) { return m.mod(f); }
	public static MelMatrix mod(MelMatrix m, double d) { return m.mod((float)d); }
	public static String mod(MelMatrix m, String s) { return m.toString()+"%"+s; }
	public static MelMatrix mod(MelMatrix m, MelVector v) { return m.mod(ConvUtils.toMatrix(v)); }
	public static MelMatrix mod(MelMatrix m1, MelMatrix m2) { return m1.mod(m2); }
	public static Object mod(MelMatrix m, Object o) { 
		if (o instanceof Boolean) return m.mod(((Boolean)o).booleanValue()?1:0); 
		if (o instanceof Integer) return m.mod(((Integer)o).intValue()); 
		if (o instanceof Float) return m.mod(((Float)o).floatValue()); 
		if (o instanceof Double) return m.mod((float)((Double)o).doubleValue()); 
		if (o instanceof String) return m+"%"+(String)o; 
		if (o instanceof MelVector) return m.mod(ConvUtils.toMatrix((MelVector)o)); 
		if (o instanceof MelMatrix) return m.mod((MelMatrix)o); 
		return new Integer(0);
	}
	

	public static Object mod(Object o, boolean b) { return mod(o, new Boolean(b)); }
	public static Object mod(Object o, int i) { return mod(o, new Integer(i)); }
	public static Object mod(Object o, float f) { return mod(o, new Float(f)); }
	public static Object mod(Object o, double d) { return mod(o, new Double(d)); }
	public static String mod(Object o, String s) { return o.toString()+"%"+s; }
	public static Object mod(Object o, MelVector v) { 
		if (o instanceof Integer) return new Float(mod(((Integer)o).intValue(), v)); 
		if (o instanceof Boolean) return new Float(mod(((Boolean)o).booleanValue(), v)); 
		if (o instanceof Float) return new Float(mod(((Float)o).floatValue(), v)); 
		if (o instanceof Double) return new Float(mod(((Double)o).doubleValue(), v)); 
		if (o instanceof String) return o+"%"+v.toString(); 
		if (o instanceof MelVector) return mod((MelVector)o, v); 
		if (o instanceof MelMatrix) return mod((MelMatrix)o, v); 
		return new Integer(0);
	}
	public static Object mod(Object o, MelMatrix m) { 
		if (o instanceof Integer) return new Float(mod(((Integer)o).intValue(), m)); 
		if (o instanceof Boolean) return new Float(mod(((Boolean)o).booleanValue(), m)); 
		if (o instanceof Float) return new Float(mod(((Float)o).floatValue(), m)); 
		if (o instanceof Double) return new Float(mod(((Double)o).doubleValue(), m)); 
		if (o instanceof String) return o+"%"+m.toString(); 
		if (o instanceof MelVector) return mod((MelVector)o, m); 
		if (o instanceof MelMatrix) return mod((MelMatrix)o, m); 
		return new Integer(0);
	}
	public static Object mod(Object o1, Object o2) { 
		if (o2 instanceof Integer) return mod(o1, ((Integer)o2).intValue()); 
		if (o2 instanceof Boolean) return mod(o1, ((Boolean)o2).booleanValue()); 
		if (o2 instanceof Float) return mod(o1, ((Float)o2).floatValue()); 
		if (o2 instanceof Double) return mod(o1, ((Double)o2).doubleValue()); 
		if (o2 instanceof String) return mod(o1, (String)o2); 
		if (o2 instanceof MelVector) return mod(o1, (MelVector)o2); 
		if (o2 instanceof MelMatrix) return mod(o1, (MelMatrix)o2); 
		return new Integer(0);
	}
}