package jmel.script;

public class AssignUtils 
{
	public static int assign(int i, boolean b) { return (b?1:0); }
	public static int assign(int i1, int i2) { return i2; }
	public static int assign(int i, float f) { return (int)f; }
	public static int assign(int i, double d) { return (int)d; }
	public static int assign(int i, String s) { return ConvUtils.toInt(s); }
	public static int assign(int i, MelVector v) { return ConvUtils.toInt(v); }
	public static int assign(int i, MelMatrix m) { return ConvUtils.toInt(m); }
	public static int assign(int i, Object o) { return ConvUtils.toInt(o); }
	
	
	public static float assign(float f, boolean b) { return (b?1:0); }
	public static float assign(float f, int i) { return i; }
	public static float assign(float f1, float f2) { return f2; }
	public static float assign(float f, double d) { return (float)d; }
	public static float assign(float f, String s) { return ConvUtils.toFloat(s); }
	public static float assign(float f, MelVector v) { return ConvUtils.toFloat(v); }
	public static float assign(float f, MelMatrix m) { return ConvUtils.toFloat(m); }
	public static float assign(float f, Object o) { return ConvUtils.toFloat(o); }
	
	
	public static double assign(double d, boolean b) { return (b?1:0); }
	public static double assign(double d, int i) { return i; }
	public static double assign(double d, float f) { return f; }
	public static double assign(double d1, double d2) { return d2; }
	public static double assign(double d, String s) { return ConvUtils.toDouble(s); }
	public static double assign(double d, MelVector v) { return ConvUtils.toDouble(v); }
	public static double assign(double d, MelMatrix m) { return ConvUtils.toDouble(m); }
	public static double assign(double d, Object o) { return ConvUtils.toDouble(o); }
	
	
	public static String assign(String s, boolean b) { return ""+(b?1:0); }
	public static String assign(String s, int i) { return ""+i; }
	public static String assign(String s, float f) { return ""+f; }
	public static String assign(String s, double d) { return ""+d; }
	public static String assign(String s1, String s2) { return s2; }
	public static String assign(String s, MelVector v) { return v.toString(); }
	public static String assign(String s, MelMatrix m) { return m.toString(); }
	public static String assign(String s, Object o) { return o.toString(); }
	
	
	public static MelVector assign(MelVector v, boolean b) { return ConvUtils.toVector(b); }
	public static MelVector assign(MelVector v, int i) { return ConvUtils.toVector(i); }
	public static MelVector assign(MelVector v, float f) { return ConvUtils.toVector(f); }
	public static MelVector assign(MelVector v, double d) { return ConvUtils.toVector(d); }
	public static MelVector assign(MelVector v, String s) { return ConvUtils.toVector(s); }
	public static MelVector assign(MelVector v1, MelVector v2) { return v2; }
	public static MelVector assign(MelVector v, MelMatrix m) { return ConvUtils.toVector(m); }
	public static MelVector assign(MelVector v, Object o) { return ConvUtils.toVector(o); }
	

	public static MelMatrix assign(MelMatrix m, boolean b) { return ConvUtils.toMatrix(b); }
	public static MelMatrix assign(MelMatrix m, int i) { return ConvUtils.toMatrix(i); }
	public static MelMatrix assign(MelMatrix m, float f) { return ConvUtils.toMatrix(f); }
	public static MelMatrix assign(MelMatrix m, double d) { return ConvUtils.toMatrix(d); }
	public static MelMatrix assign(MelMatrix m, String s) { return ConvUtils.toMatrix(s); }
	public static MelMatrix assign(MelMatrix m, MelVector v) { return ConvUtils.toMatrix(v); }
	public static MelMatrix assign(MelMatrix m1, MelMatrix m2) { return m2; }
	public static MelMatrix assign(MelMatrix m, Object o) { return ConvUtils.toMatrix(o); }


	public static MelArrayInt assign(MelArrayInt m1, MelArrayInt m2) { return m2; }
	public static MelArrayInt assign(MelArrayInt m, Object o) { return ConvUtils.toArrayInt(o); }

	public static MelArrayFloat assign(MelArrayFloat m1, MelArrayFloat m2) { return m2; }
	public static MelArrayFloat assign(MelArrayFloat m, Object o) { return ConvUtils.toArrayFloat(o); }

	public static MelArrayDouble assign(MelArrayDouble m1, MelArrayDouble m2) { return m2; }
	public static MelArrayDouble assign(MelArrayDouble m, Object o) { return ConvUtils.toArrayDouble(o); }

	public static MelArrayString assign(MelArrayString m1, MelArrayString m2) { return m2; }
	public static MelArrayString assign(MelArrayString m, Object o) { return ConvUtils.toArrayString(o); }

	public static MelArrayVector assign(MelArrayVector m1, MelArrayVector m2) { return m2; }
	public static MelArrayVector assign(MelArrayVector m, Object o) { return ConvUtils.toArrayVector(o); }
}