package jmel.script;

import java.lang.reflect.*;

public class ForUtils
{
	private int i = 0;
	private Object value;
	
	public ForUtils(MelArray value) { this.value = value; }
	public ForUtils(Object value) { this.value = value; }
	
	private Object element() {
		if (value instanceof MelArray) {
			if (i >= ((MelArray)value).getSize()) return null;
			return ((MelArray)value).readElement(i);
		}
		if (!value.getClass().isArray()) return null;
		if (i >= Array.getLength(value)) return null;
		return Array.get(value, i);
	}
		
	public boolean hasMoreElement() {
		if (value instanceof MelArray) return i < ((MelArray)value).getSize();
		if (!value.getClass().isArray()) return false;
		return i < Array.getLength(value);
	}
	
	public Object nextElement() { 
		Object obj = element(); 
		i++;
		return obj;
	}
}