package jmel.script;

public class MelArrayDouble extends MelArray
{
	public MelArrayDouble(Object value) {
		super(double.class, value);
	}
	
	public double 	getElement(int i) { return ((Double)readElement(i)).doubleValue(); }
	public double 	getElement(int i, int j) { return ((Double)readElement(i,j)).doubleValue(); }

	public void setElement(int i, double o) { writeElement(i, new Double(o)); }
	public void setElement(int i, int j, double o) { writeElement(i, j, new Double(o)); }
	
	public double[] get() { return (double[])getValue(); }
	
	public void setValue(int i, Object val) {
		if (val instanceof Number) val = new Double(((Number)val).doubleValue());
		writeElement(i,val);
	}
	
	public void setValue(int i, int j, Object val) {
		if (val instanceof Number) val = new Double(((Number)val).doubleValue());
		writeElement(i,j,val);
	}
}