package jmel.script;

public class MelArrayInt extends MelArray
{
	public MelArrayInt(Object value) {
		super(int.class, value);
	}
	
	public int 	getElement(int i) { return ((Integer)readElement(i)).intValue(); }
	public int 	getElement(int i, int j) { return ((Integer)readElement(i,j)).intValue(); }

	public void setElement(int i, int o) { writeElement(i, new Integer(o)); }
	public void setElement(int i, int j, int o) { writeElement(i, j, new Integer(o)); }
	
	public int[] get() { return (int[])getValue(); }
	
	public void setValue(int i, Object val) {
		if (val instanceof Number) val = new Integer(((Number)val).intValue());
		writeElement(i,val);
	}
	
	public void setValue(int i, int j, Object val) {
		if (val instanceof Number) val = new Integer(((Number)val).intValue());
		writeElement(i,j,val);
	}
}