package jmel.script;

import java.lang.reflect.Array;

public class MelArrayString extends MelArray
{
	public MelArrayString(Object value) {
		super(String.class, value);
	}
	
	public String 	getElement(int i) { return (String)readElement(i); }
	public String 	getElement(int i, int j) { return (String)readElement(i,j); }

	public void setElement(int i, String o) { writeElement(i, o); }
	public void setElement(int i, int j, String o) { writeElement(i, j, o); }
	
	public String[] get() { return (String[])getValue(); }
	
	public String toString() {
		Object value = getValue();
		int length = Array.getLength(value);
		String tmp = "";
		for (int i = 0; i < length; i++) {
			tmp += "\"" + Array.get(value, i).toString() + "\"";
			if (i < length-1) tmp += " ";
		}
		return tmp;
	}
}